/* Program name --- join.c  2004.9.6 */

#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>
#include        <time.h>
#include        "multicorr.h"

#define     DBG          0

#define     BUFSIZE      100

/* for memory allocation */
extern void malloc_float();
extern void malloc_int();
extern float *allot_float();
extern int *allot_int();
float *buf_float;
int   *buf_int;
int   float_cnt, int_cnt;
int   limit_float, limit_int;
/* for memory allocation */

void readfile();
void error(char *);

main(argc,argv)
int	argc;
char	*argv[];
{
  int   i, j, p, s1, s2;
  int   length, sequences;
  char  dbfile[128], dblist[128], outputfile[128];

  struct streamData **stream, *buf_stream;

  char  read_buf[BUFSIZE];
  FILE  *fp1;

  if(argc != 4){
    error(argv[0]);
    exit(1);
  }
  strcpy(dblist,argv[1]);
  length = atoi(argv[2]);
  strcpy(outputfile,argv[3]);

  /*
   * Read data sequences
   */
  if ( ( fp1 = fopen ( dblist , "r" ) ) == NULL ){
    printf( "  %s can not open\n" , dblist);
    exit(1);
  }
  i=0;
  while (fgets(read_buf,BUFSIZE,fp1) != NULL ){
    i++;
  }
  sequences = i;
  rewind(fp1);

  /*
   * memory allocation
   */
  stream = (struct streamData **)malloc(
         sizeof(struct streamData *) * sequences);
  buf_stream = (struct streamData *)malloc(
         sizeof(struct streamData) * sequences);
  if (stream == NULL || buf_stream == NULL){
    printf("Allocation error : stream\n");
    exit(1);
  }

  j = 0;
  /* stream */
  j += length * sequences;

  malloc_float(j);

  for (i=0 ; i<sequences ; i++) {
    stream[i] = buf_stream + i;
    stream[i]->value = allot_float(length);
  }

  /*
   * Read data sequences
   */
  i=0;
  while (fgets(read_buf,BUFSIZE,fp1) != NULL ){
    sscanf(read_buf,"%s\n", dbfile);
    readfile(dbfile, stream, i, length);
    i++;
  }
  fclose(fp1);

  /*
   * Write multiple data sequences
   */
  if ( ( fp1 = fopen ( outputfile , "w" ) ) == NULL ){
    printf( "  %s can not open\n" , outputfile);
    exit(1);
  }
  for (i=0 ; i<length ; i++){
    for (j=0 ; j<sequences ; j++){
      fprintf(fp1, "%f", stream[j]->value[i]);
      if (j != sequences - 1)
	fprintf(fp1, " ");
    }
    fprintf(fp1, "\n");
  }
  fclose(fp1);

  free(buf_float);
  free(buf_stream);
  free(stream);
}

void readfile(filename, stream, id, len)
char *filename;
struct streamData **stream;
int id;
int len;
{

  int j;
  char  readbuf[BUFSIZE];
  FILE  *fp;

  if ( ( fp = fopen ( filename , "r" ) ) == NULL ){
    printf( "  %s can not open\n" , filename);
    exit(1);
  }

  j = 0;
  while (fgets(readbuf,BUFSIZE,fp) != NULL ){
    stream[id]->value[j] = atof(readbuf);
    j++;
    if (j > len) break;
  }
  if (j < len)
    printf("Warning: sequence is short. length=%d\n", j);
  fclose(fp);
}

void error(char *toolname){
  fprintf(stderr,"Usage : %s  dblist  length  outputfile\n",toolname);
  exit(1);
}
