/* Program name --- sindata.c
 *       written by Sakurai   2002.8.6
 */

#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>
#include        <math.h>
#include        <time.h>

extern double ran1_m();

void error(char *);

main(argc,argv)
int	argc;
char	*argv[];
{

    int i, j, length, iter, offset, num;
    int seed;
    float  delta, theta, val, *y, noise;

    if(argc != 5)
    {
        error(argv[0]);
        exit(1);
    }
    iter = atoi(argv[1]);
    offset = atoi(argv[2]);
    noise = atof(argv[3]);
    length = atoi(argv[4]);

    if (length % iter != 0 || offset > length){
        printf("Error : length %d, iteration %d offset %d\n", length, iter, offset);	
        exit(1);
    }
    y = (float *)malloc(sizeof(float) * length);
    if (y == NULL){
      printf("Allocation error : y\n");
      exit(1);
    }
    for (i=0 ; i<length ; i++)
      y[i] = 0;
    num = length / iter;
    delta = M_PI * 2 / (double)num;
    srand(time(0));
    seed = rand();
    for (i=0 ; i<iter ; i++){
        for (j=0 ; j<num ; j++){
            theta = delta * j;
	    y[i*num+j] = sin(theta) + noise * ran1_m(&seed);
	}
    }
    for (i=offset ; i<length ; i++)
        printf("%f\n", y[i]);
    for (i=0 ; i<offset ; i++)
        printf("%f\n", y[i]);
}     

void error(char *toolname){
    fprintf(stderr,"Usage : %s  iteration  offset  noise  length\n",toolname);
    exit(1);
}

